local sti = require "sti"
local gr = love.graphics
bump = require "bump"
world = bump.newWorld(50)
bump_debug = require 'bump_debug'


function gameload()
	map = sti.new("maps/map_1")  
	playerload()
    enemiesLayer = map.layers["enemies"]
    camera:setBounds(0, 0, map.width * map.tilewidth - love.graphics.getWidth(), map.height * map.tileheight - love.graphics.getHeight() )
    --creating solid block info
    local mapfunction = love.filesystem.load("maps/map_1.lua")
    local mapdatatable = mapfunction()
    maptilesetdata = {}
    for x = 1, mapdatatable.layers[1].width do 
    	maptilesetdata[x] = {} 
    	for y = 1, mapdatatable.layers[1].height do 
    		maptilesetdata[x][y] = mapdatatable.layers[1].data[(y-1)*mapdatatable.layers[1].width+x]

    		if maptilesetdata[x][y] ~= 0 then 
    			block_create((x-1)*32, (y-1)*32)
    		end
    	end 
    end
    --create Collision Blocks from tiled solid blocks
    for i,v in pairs(blocks) do 
    	world:add(blocks[i], v.x,v.y,v.w,v.h)
    end 

    for i,v in ipairs(enemiesLayer.objects) do
        if v.properties.enemy then 
            enemy_create(v.x, v.y, v.width, v.height)
            world:add(enemies[i], v.x,v.y,v.width,v.height)
        end
    end


end

function gameupdate(dt)
	map:update(dt)
	playerupdate(dt)
    camera:setPosition(playerlayer.player.x - (love.graphics.getWidth()/2), playerlayer.player.y - (love.graphics.getHeight()/2))
    

end

function gamedraw()
	gr.setBackgroundColor(0,0,0)
 	camera:set()
 	map:setDrawRange(0, 0, map.width * map.tilewidth, map.height * map.tileheight)
    --map:draw()
    playerdraw()
    --draw Collision grid
	for i,v in pairs(blocks) do 
    	drawBox(v, 0,40,0)
    end
    --draw Collison box for enemies
    for i,v in pairs(enemies) do 
        drawBox(v, 0,0,255)
    end   
    --drawDebug()
    camera:unset()
    --[[gr.setColor(255,255,255)
            gr.print("Is on Ground = "..tostring(player.onGround), 630, 580 )
            gr.print("Has Jumped = "..tostring(player.hasJumped), 630, 570 )
            gr.print("Facing = "..tostring(playerlayer.player.facing), 630, 560 )
            gr.print("LN "..tostring(mln1).." "..tostring(mln2).." "..tostring(mln3),500, 550 )
            gr.print(love.mouse.getX().." "..tostring(love.mouse.getY()),10,10)]]

end

function drawDebug()
  bump_debug.draw(world)

  statistics = ("fps: %d, mem: %dKB"):format(love.timer.getFPS(), collectgarbage("count"))
  love.graphics.setColor(255, 255, 255)
  
end


function gamekeypressed(key)
    if key == "escape" then 
        love.event.quit()
    end
end
function drawBox(box, r,g,b)
  love.graphics.setColor(r,g,b,70)
  love.graphics.rectangle("fill", box.x, box.y, box.w, box.h)
  love.graphics.setColor(r,g,b)
  love.graphics.rectangle("line", box.x, box.y, box.w, box.h)
end
--Execute Cunctions in Properties of objects
--[[for i,v in ipairs(objLayer.objects) do  --обрабатываем объекты, которые уже есть на карте
        if v.properties.ai then v.ai = exec(v.properties.ai) end  --ИИ
        if v.properties.draw then v.draw = exec(v.properties.draw) end  --отрисовка
        if v.properties.action then v.action = exec(v.properties.action) end  --действие
    end
end

function exec( s )
    return loadstring( 'return ' .. s )()
end]]