local down = love.keyboard.isDown
local gr = love.graphics
Timer = require "hump.timer"
--player collison box
local gravity = 500
local walk_speed   = 500
local jump_speed   = 400

player = { x=50,y=50,w=28,h=28, vx=0, vy=0}
player.onGround = false
player.hasJumped = false


function playerload()
  PlayerJumpTimer = Timer.new()
	--player collison box
	world:add(player, player.x,player.y,player.w,player.h)
	--actual player look
	playerlayer = map.layers["player"]
	playerlayer.player = {
		x = player.x,
		y = player.y,
		w = player.w,
		h = player.h
	}
  playerlayer.player.facing = "left"
	function playerlayer:update(dt)

	end

	-- actual player draw
	function playerlayer:draw()
		local x = math.floor(self.player.x)
		local y = math.floor(self.player.y)
		gr.setColor(255,255,255)
		love.graphics.rectangle('fill',self.player.x,self.player.y,self.player.w,self.player.h)
	end
end
function playerupdate(dt)
	updatePlayer(dt)
  PlayerJumpTimer:update(dt)
	--player collision box attached to actual player
	playerlayer.player.x = player.x
	playerlayer.player.y = player.y


end
function playerdraw()
	--draw Player Collision box
	drawBox(player, 0,255,0)
end

--player collision box update
function updatePlayer(dt)
  player.vx = 0

  if love.keyboard.isDown('d') then
    player.vx = walk_speed
    playerlayer.player.facing = "left"
  elseif love.keyboard.isDown('a') then
    player.vx = -walk_speed
    playerlayer.player.facing = "right"
  end

  player.vy = player.vy + gravity * dt

  if love.keyboard.isDown('w') and player.onGround then
    player.vy = -jump_speed
  end

  local dx, dy = player.vx * dt, player.vy * dt

  if dx ~= 0 or dy ~= 0 then
    player.onGround = false
    local future_l, future_t = player.x + dx, player.y + dy
    local cols, len = world:check(player, future_l, future_t)

    if len == 0 then
      player.x, player.y = future_l, future_t
      world:move(player, future_l, future_t)
    else
      local col, tl, tt, nx, ny, sl, st
      while len > 0 do
        col = cols[1]
        tl,tt,nx,ny,sl,st = col:getSlide()
        if ny < 0 then
          player.onGround = true
          if player.vy > 0 then player.vy = 0 end
        end
        player.x, player.y = tl, tt
        world:move(player, tl, tt)
        cols, len = world:check(player, sl, st)
        if len == 0 then
          player.x, player.y = sl, st
          world:move(player, sl, st)
        end
      end
    end
  end
end
